program SecondDer1D

! Take Second derivative of input file

  use sep
  use waveprop3d_mod


implicit none


 logical    :: adj
 integer    :: nt
 real       :: ot, dt
 real, dimension(:), allocatable :: model

 call sep_init()


   write(0,*) ' This is SecondDer1D program'


   ! read in type of filter
   call from_param("adj",adj,.true.);


  ! Read back ground mmocity param
   call from_history("n1", nt);  call from_history("d1", dt);  call from_history("o1",ot);
  
   write(0,*) 'nt,dt,ot', nt, dt, ot
   write(0,*) 'adj', adj

   allocate( model(nt))

   ! Read in the model
    call sep_read( model(1:nt))

    call Ver2ndDer1D(adj,model,nt)

!----------------------------------------------
! Output

  call sep_write(model,esize=4)
  call to_history("n1",nt); call to_history("d1",dt);  call to_history("o1",ot);
  
end program
