#! /usr/bin/env python
#from SEP import *
import commands,re,string,sys,os
import datetime
import sys
from array import *
#import Numeric
import subprocess

# This script submit 100 jobs but only 4 jobs is running at a time
# it constantly check rather a there are < 4 jobs, if so it submit more


from pyLoc import *

plet='B'

Nproc=400

maindir = 'MWfile/B'


savDir = "%s"%(maindir)
sbin = "bin"
sepb = "/usr/local/SEP/bin"
nodes = 1   # number of nodes for each job
ppn=16     # number of processor per node
walltime='24:00:00'  # max time to wait for the job to finish
pmem = '1gb'  # max memory to allocate for the job
jobname = 'MWgt%s_'%(plet) # Job name 

parfile = 'Par/MWgtA.par'

os.system("rm -f out1.par; sed '/#/d' %s | sed '/^$/d' | tr '\n' ' ' > out1.par"%(parfile))
f1 = open("out1.par")
param = f1.readline()
f1.close()
print 'param', param

#for i in [10]:	
for i in K[:]:
	a1 = '%s'%(L[i][0])
	Gx = L[i][0]
	Gy = L[i][1]
	Gz = L[i][2]
	submitted = 0
	if (os.path.isdir('%s/pbs'%(savDir)) != 1):
		os.system('mkdir %s/pbs'%(savDir))
	if (os.path.isdir('%s/logfile'%(savDir)) != 1):
		os.system('mkdir %s/logfile'%(savDir))
	cmdfile = "%s/pbs/PBS%s%s.txt"%(savDir,plet,i)
	logfile = "%s/logfile/fm%s.txt"%(savDir,i)
	os.system("rm -f %s %s"%(cmdfile,logfile))
	while (submitted == 0):
		# flag = number of job running
		cmd0="qstat | grep \"mandyman\" | grep \"%s\" -c >& %s/count.txt"%(jobname,savDir)
		print cmd0
		os.system(cmd0)
		stg1 = "%s/count.txt"%(savDir)
		f = open(stg1)
		os.system("rm -f %s/count.txt"%(savDir))
		flag = int(f.readline())	
		f.close()
		print 'number of proc found', flag	
		
		if (flag < Nproc):
			print 'MWgt: submitting shot #', i
			cmd0 ='python pycode/pyRemove.py %s/mwfile%s%s.H '%(savDir,plet,i)
			cmd1 = 'bin/ModWgt.x %s xsrc=%s zsrc=%s npad=20 outfile=%s/mwfile%s%s.H >& %s'%(param,Gx,Gz,savDir,plet,i,logfile)
			print cmd1
			os.system("echo '%s' >> %s"%(cmd0,cmdfile))
			os.system("echo '%s' >> %s"%(cmd1,cmdfile))
			# generate the pbs scripts 
			cmd1 = "pycode/pyWritePBS.py %s %s %s %s %s%s %s"%(nodes,ppn,walltime,pmem,jobname,i,cmdfile)
			os.system( cmd1)
			submitted = 1
			os.system('sleep 2')
		else:
			print 'Number of proc',flag,'wait 20'
			os.system("sleep 20")

flag=1

while (flag > 0):	
	# flag = number of job running
	os.system("qstat | grep \"mandyman\" | grep \" C \" -v | grep \"%s\" -c >& %s/count.txt"%(jobname,savDir)) 
	f = open("%s/count.txt"%(savDir))
	os.system("rm -f %s/count.txt"%(savDir))
	flag = int(f.readline())	
	f.close()	
	os.system("rm -f %s/count.txt"%(savDir))
	print "Number of proc",flag,",not done yet, sleep 20"
	os.system("sleep 20")


print "Good bye!"


