# A script that does conjugate gradient calculations
#! /usr/bin/env python
#from SEP import *
import commands,re,string,sys,os
import datetime
import sys
import subprocess
sys.path.append('./pycode')
from pyLoc import *


projdir = sys.argv[1]
plet    = sys.argv[2]
iter  = int(sys.argv[3])
datax = int(sys.argv[4])
modax = int(sys.argv[5])
dirdm   = sys.argv[6]
dirggm   = sys.argv[7]
dirgg   = sys.argv[8]
dirrr   = sys.argv[9]
dirrrm   = sys.argv[10]
dirss   = sys.argv[11]
dirssm   = sys.argv[12]

# initialization
ggdrr = 0.
ggdgg = 0.
ssdss = 0.
ssdrr = 0.
ssdgg = 0.
resid = 0.
dmDdm = 0.
ggmdrrm = 0.
ggmdggm = 0.
ssmdssm = 0.
ssmdrrm = 0.
ssmdggm = 0.
residm = 0.
ggDdrrD = 0.
ggDdggD = 0.
ssDdssD = 0.
ssDdrrD = 0.
ssDdggD = 0.
residD = 0.
# Calculagte residual in model space
# Calculate ddmDddm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%sTotaliter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirdm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
dmDdm = dmDdm + float(str1)
# Calculate ggmdggm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
ggmdggm = ggmdggm + float(str1)
# calculate ggmdrrm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,dirrrm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
ggmdrrm = ggmdrrm + float(str1)
       # calculate ggmdssm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,dirssm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
ssmdggm = ssmdggm + float(str1)
# Calculate ssmdssm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirssm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
ssmdssm = ssmdssm + float(str1)
# calculate ssmdrrm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirssm,iter,dirrrm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
ssmdrrm = ssmdrrm + float(str1)
# Calculate rrmdrrm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirrrm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
residm = residm + float(str1)

# Dot products of data space Residual
for i in K[:]:
	shot=i

	# calculating ggdgg
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggDdggD = ggDdggD + float(str1)
        # Calculating ggdrr
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,dirrr,shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggDdrrD = ggDdrrD + float(str1)
	# calculating ssdss
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirss,shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ssDdssD = ssDdssD + float(str1)
	# calculating rrdrr
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr,shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	residD = residD + float(str1)
	# Calculating ssdrr
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin, datax,dirss,shot,iter,dirrr,shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ssDdrrD = ssDdrrD + float(str1)
	# Calculating ssdgg
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin, datax,dirss,shot,iter,dirgg,shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ssDdggD = ssDdggD + float(str1)


ggdgg = ggDdggD + ggmdggm
ggdrr = ggDdrrD + ggmdrrm
ssdss = ssDdssD + ssmdssm
ssdrr = ssDdrrD + ssmdrrm
ssdgg = ssDdggD + ssmdggm
resid = residD  + residm
# CG step to calculate alpha and beta
os.system("rm -f "+projdir+"/alpha.txt")
print 'before modcgstep';
cmd1 = "%s/modcgstep.x Forget=0 ggdgg=%s ggdrr=%s ssdss=%s ssdrr=%s ssdgg=%s outtag='%s/alpha.txt' >/dev/null "%(sbin,ggdgg,ggdrr,ssdss,ssdrr,ssdgg,projdir)
os.system(cmd1)
f = open(projdir+"/alpha.txt")
alpha = float(f.readline())
beta  = float(f.readline())
f.close()


# Saves the residual in data space
file = open(projdir+"/ResidualData.txt","a")
cmd1 = "%s %s %s %s %s %s %s \n "%(iter, ggDdggD, ggDdrrD,ssDdssD,ssDdrrD,ssDdggD,residD)
file.writelines(cmd1);
file.close()
# Saves the residual in model space
file = open(projdir+"/ResidualModel.txt","a")
cmd1 = "%s %s %s %s %s %s %s \n "%(iter, ggmdggm, ggmdrrm,ssmdssm, ssmdrrm, ssmdggm, residm)
file.writelines(cmd1);
file.close()
# Saves the total residual
file = open(projdir+"/ResidualTotal.txt","a")
cmd1 = "%s %s %s %s %s %s %s \n "%(iter, ggdgg, ggdrr, ssdss, ssdrr, ssdgg, resid)
file.writelines(cmd1);
file.close()

# Saves the percent residual
file = open(projdir+"/ResidualPercent.txt","a")
cmd1 = "%s %s %s %s %s %s %s \n "%(iter, str(round(ggmdggm/ggdgg*100,2)), str(round(ggmdrrm/ggdrr*100,2)), str(round(ssmdssm/ssdss*100,2)),  str(round(ssmdrrm/ssdrr*100,2)), str(round(ssmdggm/ssdgg*100,2)), str(round(residm/resid*100,2)))
file.writelines(cmd1);
file.close()

# Save the alpha, beta, and residual
file = open(projdir+'/Reportsave.txt', 'a')
cmd1 = " %s %s %s %s %s %s %s \n"%(iter,alpha,beta, dmDdm, residD, residm, resid)
file.writelines(cmd1);
file.close()

