# A script that does conjugate gradient calculations
#! /usr/bin/env python
#from SEP import *
import commands,re,string,sys,os
import datetime
import sys
import subprocess
sys.path.append('./pycode')
from pyLoc import *


projdir = sys.argv[1]
plet    = sys.argv[2]
iter  = int(sys.argv[3])
datax = int(sys.argv[4])
modax = int(sys.argv[5])
dirdm   = sys.argv[6]
dirggm   = sys.argv[7]
dirgg   = sys.argv[8]
dirrr   = sys.argv[9]
dirrrm   = sys.argv[10]


# initialization
ggdgg = 0.
ggdrr = 0.
resid = 0.
residD = 0.
residm = 0.
dmDdm = 0.
ggmdggm = 0.
ggDdggD = 0.
ggmdrrm = 0.
ggDdrrD = 0.
sbin='bin'

# Calculagte residual in model space
# Calculate ddmDddm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%sTotaliter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirdm,iter,projdir)
os.system(cmd1)

f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
dmDdm = dmDdm + float(str1)
# Calculate ggmdggm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,projdir)
os.system(cmd1)

f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
ggmdggm = ggmdggm + float(str1)
# calculate ggmdrrm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,dirrrm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
ggmdrrm = ggmdrrm + float(str1)
# calculate rrmdrrm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirrrm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
residm = residm + float(str1)

# calculating residual in data space
for i in K[:]:
	shot = i
	# calculating ggdgg
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggDdggD = ggDdggD + float(str1)
	# Calculating ggdrr
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,dirrr,shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggDdrrD = ggDdrrD + float(str1)
	# calculating rrdrr
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr,shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	residD = residD + float(str1)

ggdgg = ggDdggD + ggmdggm
ggdrr = ggDdrrD + ggmdrrm
resid = residD  + residm


# Perform cg step to get alpha
os.system("rm -f "+projdir+"/alpha.txt")
cmd1="%s/modcgstep.x Forget=1 ggdgg=%s ggdrr=%s outtag=%s/alpha.txt >/dev/null "%(sbin,ggdgg,ggdrr,projdir)
os.system(cmd1)
f = open(projdir+"/alpha.txt")
alpha = float(f.readline())
beta = 0.
f.close()

# Saves the residual in data space	
os.system('rm -f '+projdir+'/ResidualData.txt')
file = open(projdir+"/ResidualData.txt","w")
cmd1 = "Iter ggDdggD ggDdrrD ssDdssD ssDdrrD ssDdggD residD \n"
file.writelines(cmd1);
cmd1 = "1 %s %s 0. 0. 0. %s \n "%(ggDdggD, ggDdrrD,residD)
file.writelines(cmd1);
file.close()
# Saves the residual in model space
os.system('rm -f '+projdir+'/ResidualModel.txt')
file = open(projdir+"/ResidualModel.txt","w")
cmd1 = "Iter ggmdggm ggmdrrm ssmdssm ssmdrrm ssmdggm residm \n"
file.writelines(cmd1);
cmd1 = "1 %s %s 0. 0. 0. %s \n "%(ggmdggm, ggmdrrm,residm)
file.writelines(cmd1);
file.close()
# Saves the total residual
os.system('rm -f '+projdir+'/ResidualTotal.txt')
file = open(projdir+"/ResidualTotal.txt","w")
cmd1 = "Iter ggdgg ggdrr ssdss ssdrr ssdgg resid \n"
file.writelines(cmd1);
cmd1 = "1 %s %s 0. 0. 0. %s \n "%(ggdgg, ggdrr,resid)
file.writelines(cmd1);
file.close()
# Saves the percent residual
file = open(projdir+"/ResidualPercent.txt","w")
cmd1 = "Iter ggdgg ggdrr ssdss ssdrr ssdgg resid \n"
file.writelines(cmd1);
cmd1 = "1 %s %s 0.00 0.00 0.00 %s \n "%(str(round(ggmdggm/ggdgg*100,2)), str(round(ggmdrrm/ggdrr*100,2)), str(round(residm/resid*100,2)))
file.writelines(cmd1);
file.close()


# Save the step size
file = open(projdir+'/Reportsave.txt',"w")
file.writelines("iter alpha beta dmDdm Data_resid Model_resid Objective \n")
cmd1 = " 1 %s 0. %s %s %s %s \n "%(alpha, dmDdm, residD, residm, resid)
file.writelines(cmd1);
file.close()

