#! /usr/bin/env python
#from SEP import *
import commands 
import re,string
import sys, os
import os.path 
sys.path.append('./pycode')
from pyLoc import *


i = int(sys.argv[1])
jobname = sys.argv[2]
iter = int(sys.argv[3])
outdir = sys.argv[4]
projdir = sys.argv[5]
plet    = sys.argv[6]
velfile = sys.argv[7]
parfile = sys.argv[8]
smooth  = sys.argv[9]
lpfil   = sys.argv[10]
VDer    = sys.argv[11]
gauss   = sys.argv[12]
DW      = sys.argv[13]
nhx     = sys.argv[14]
MWfile = sys.argv[15]
DWfile  = sys.argv[16]

nodes = 1   # number of nodes for each job
ppn=16     # number of processor per node
walltime='24:00:00'  # max time to wait for the job to finish
pmem = '2gb'  # max memory to allocate for the job

os.system("rm -f %s/out1.par; sed '/#/d' Par/%s | sed '/^$/d' | tr '\n' ' ' > %s/out1.par"%(projdir,parfile,projdir))
f1 = open("%s/out1.par"%(projdir))
param = f1.readline()
f1.close()
#print 'param', param
dirgg = projdir+"/gg/ggArt"+plet
dirdm = projdir+"/dm/dmArt"+plet

# Constructing logfile and cmdfile
if (os.path.isdir('%s/pbs'%(outdir)) != 1):
        os.system('mkdir %s/pbs'%(outdir))
if (os.path.isdir('%s/logfile'%(outdir)) != 1):
        os.system('mkdir %s/logfile'%(outdir))
cmdfile = "%s/pbs/PBS%s%s.txt"%(outdir,plet,i)
logfile = "%s/logfile/For%s.txt"%(outdir,i)
os.system("rm -f %s %s"%(cmdfile,logfile))

Gx = L[i][0]
Gy = L[i][1]
Gz = L[i][2]

cmd0 ='python pycode/pyRemove.py %s%siter%s.H %s/tmp%s%s.H %s/tmpp%s%s.H '%(dirgg,i,iter,outdir,plet,i,outdir,plet,i)
cmd1='bin/bornmodel.x < Input/%s aux=Input/wavelet2.H %s VDer=%s mwfile=%s%s.H DW=%s DWfile=%s%s.H xsrc=%s zsrc=%s npad=30 imgfile=%sTotaliter%s.H wfldout=0  outfile=%s/tmp%s%s.H  >& %s'%(velfile,param,VDer,MWfile,i,DW,DWfile,i,Gx,Gz,dirdm,iter,outdir,plet,i,logfile)
print cmd1
cmd2 = ' < %s/tmp%s%s.H ${SEPBIN}/Bandpass flo=3. fhi=25. > %s%siter%s.H'%(outdir,plet,i,dirgg,i,iter)
cmd4 = 'python pycode/pyRemove.py  %s/tmp%s%s.H %s/tmpp%s%s.H'%(outdir,plet,i,outdir,plet,i)
os.system("echo '%s' >> %s"%(cmd0,cmdfile))
os.system("echo '%s' >> %s"%(cmd1,cmdfile))
os.system("echo '%s' >> %s"%(cmd2,cmdfile))
os.system("echo '%s' >> %s"%(cmd4,cmdfile))



curfile = projdir+'/JN/JNFor%siter%s.txt'%(plet,iter)
newnode='1'
prevjobname = 'Adj%siter%s'%(plet,iter)
prevfile = projdir+'/JN/JN%s.txt'%(prevjobname)
if (os.path.exists(prevfile)):
	# look for node# of previous Forward job
	cmd1 = "more %s | grep %s_%s | awk '{print $4}' "%(prevfile,prevjobname,i)
	#print cmd1
	node = os.popen(cmd1).read()
	node = node[:len(node)-1]
else:
	node='nan'

# If the node is free, submit jobs to that node, else just random ones
C1 = (int(node.find('rcf')) >= 0)
cmd2 = "pbsnodes -l free | awk '{print $1}' | grep %s -c"%(node)
free = int(os.popen(cmd2).read())
C2 = (int(free) > 0)


if (C1 and C2):
	#  submit to the previous node
	print C1, C2
	newnode=node
else:
	# submit to new node
	tmpfile = 'tmp%s.txt'%(i)
	os.system('rm %s'%(tmpfile))
	cmd3 = "pbsnodes | grep -vE '(status|gpus|jobs|ntype|np)' | perl -p -e 's/\\n/ /' | perl -pi.bak -e 's/ral/ral\\n/g' | perl -pi.bak -e 's/ass/ass\\n/g' | grep -vE '(class|job)' | grep 'free' | awk '{print $1}' >> %s"%(tmpfile)
	os.system(cmd3)
	num_free = sum(1 for line in open(tmpfile))
	f1=open(tmpfile)
	# loop over number of free node
	for i in range(1,num_free):
		curnode = f1.readline()
		curnode = curnode[0:6]
		outstring = os.popen('more %s | grep %s'%(curfile,curnode)).read()
		if (len(outstring) < 1):
			newnode = curnode;
			break;
	os.system('rm %s'%(tmpfile))
	f1.close()

newnode='1'
cmd1 = "pycode/pyWritePBS.py %s %s %s %s %s %s"%(1,ppn,walltime,pmem,jobname,cmdfile)
print cmd1	
os.system( cmd1)
os.system('sleep 2')

# print out job and node info
cmd1 = 'python pycode/pyJobnode.py %s %s'%(jobname,curfile)
os.system(cmd1)
	

