
include SEPmandy1bw.make

lsz = titlesz=14 titlefat=1 labelrot=y labelfat=1 labelsz=12 wheretitle=t 
lsz2 = titlesz=8 titlefat=-1 labelrot=y labelfat=-1 labelsz=7 wheretitle=t 
gpar= min2=0. max2=1. title=' ' label2='Amplitude' label1='x(m)' $(lsz) screenratio=0.29 dash=[0,4]
gpar2 = >/dev/null title=' ' $(lsz) wheretitle=t crowd=0.75 whereylabel=l wherexlabel=b wheretics=f pclip=99  newclip=1 label1='z(m)' label2='x(m)' screenratio=0.23 wantaxis2=0
gpar3 = >/dev/null title=' ' $(lsz) wheretitle=t crowd=0.70 whereylabel=l wherexlabel=b wheretics=f pclip=98  newclip=1 label1='t(s)' label2='x(m)'  wantaxis2=0
gpar4 = >/dev/null title=' ' $(lsz) wheretitle=t crowd=0.70 whereylabel=l wherexlabel=b wheretics=f pclip=98  newclip=1 label1='t(s)' label2='x(m)' screenratio=0.4

Vfigvel.v: 
	rm -f t1.v t2.v
	${SEPBIN}/Grey < Input/velZiglayer.H $(gpar4) color=j newclip=1 title='(a)' wantaxis2=0 out=junk1.v >/dev/null
	${SEPBIN}/Grey < Input/velZigsmoothv2.H $(gpar4) color=j newclip=1 title='(b)' out=junk2.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=8.2 > 1.v
	vppen < junk2.v vpstyle=n xshift=0. yshift=0 > 2.v
	vppen 1.v 2.v  erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v junk*.v

Vfig2img.v: bin/SecondDer3D.x
	python pycode/pyRemove.py mMbp*H out*H
	Add  Data/mArtCTotaliter2.H Data/mwfileA10.H mode=prod > out1.H
	< out1.H bin/SecondDer3D.x VDer=1 | ${SEPBIN}/Bandpass flo=0.005 fhi=0.015 > mMbp1.H
	< mMbp1.H  ${SEPBIN}/Grey $(gpar2) title='(a)'  out=junk1.v >/dev/null
	${SEPBIN}/Window3d < mMbp1.H n1=2 f1=198 j1=50 | ${SEPBIN}/Transp | ${SEPBIN}/Scale | ${SEPBIN}/Graph n2=2 $(gpar) title='(a)' out=junka.v wantaxis2=1 wantaxis1=0 >/dev/null
	Add  Data/mArtCTotaliter20.H Data/mwfileA10.H mode=prod > out2.H
	< out2.H bin/SecondDer3D.x VDer=1 | ${SEPBIN}/Bandpass flo=0.005 fhi=0.015 > mMbp2.H
	< mMbp2.H  ${SEPBIN}/Grey $(gpar2)  title='(b)' out=junk2.v wantaxis2=0 >/dev/null
	${SEPBIN}/Window3d < mMbp2.H n1=2 f1=198 j1=50 | ${SEPBIN}/Transp | ${SEPBIN}/Scale | ${SEPBIN}/Graph n2=2 $(gpar) title='(b)' wantaxis1=0 wantaxis2=1 out=junkb.v >/dev/null
	< Data/mArtFTotaliter20.H bin/SecondDer3D.x VDer=1 | ${SEPBIN}/Bandpass flo=0.005 fhi=0.015 > out3.H
	Add  out3.H Data/mwfileA10.H mode=prod > mMbp3.H
	< mMbp3.H ${SEPBIN}/Grey $(gpar2) title='(c)'  out=junk3.v >/dev/null
	${SEPBIN}/Window3d < mMbp3.H n1=2 f1=200 j1=50 | ${SEPBIN}/Transp | ${SEPBIN}/Scale | ${SEPBIN}/Graph n2=2 $(gpar) title='(c)'  wantaxis1=0 wantaxis2=1 out=junkc.v >/dev/null
	< Data/mArtMTotaliter20.H bin/SecondDer3D.x VDer=1 | ${SEPBIN}/Bandpass flo=0.005 fhi=0.015 > out4.H
	Add  out4.H Data/mwfileA10.H mode=prod > mMbp4.H
	< mMbp4.H  ${SEPBIN}/Grey $(gpar2) title='(d)' wantaxis2=0 out=junk4.v >/dev/null
	${SEPBIN}/Window3d < mMbp4.H n1=2 f1=201 j1=50 | ${SEPBIN}/Transp | ${SEPBIN}/Scale | ${SEPBIN}/Graph n2=2 $(gpar) title='(d)' wantaxis2=1 wantaxis1=1 out=junkd.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=25.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=0 yshift=17. > 2.v
	vppen < junk3.v vpstyle=n xshift=0 yshift=8.5 > 3.v
	vppen < junk4.v vpstyle=n xshift=0 yshift=0 > 4.v
	vppen < junka.v vpstyle=n xshift=0 yshift=27.5 > a.v
	vppen < junkb.v vpstyle=n xshift=0 yshift=18.5 > b.v
	vppen < junkc.v vpstyle=n xshift=0 yshift=9.5 > c.v
	vppen < junkd.v vpstyle=n xshift=0 yshift=0.5 > d.v
	vppen 1.v 2.v 3.v 4.v erase=n scale=0.2 > Vfig2img.v
	vppen a.v b.v c.v d.v erase=n scale=0.2 > Vfig3img.v
	rm -f 1.v 2.v 3.v 4.v a.v b.v. c.v. d.v junk*.v
	python pycode/pyRemove.py mMbp*.H out*H

gpar5 = >/dev/null title=' ' $(lsz2) wheretitle=t crowd=0.70 whereylabel=l wherexlabel=b wheretics=f pclip=98  newclip=1 label1='t(s)' label2='x(m)' wantaxis2=0 screenratio=1.5 n2tic=5


Vfig4resid.v:
	python pycode/pyRemove.py $@ tmp1.H
	Math file1=Data/rrArtF190iter1.H exp='file1*file1' | Grey $(gpar5) title='(a)' out=junk1.v >/dev/null
	Math file1=Data/rrArtF190iter20.H exp='file1*file1' | Grey $(gpar5) title='(b)' wantaxis1=0 out=junk2.v >/dev/null
	Math file1=Data/rrArtM190iter1.H exp='file1*file1' | Grey $(gpar5) title='(c)' wantaxis2=1 out=junk3.v >/dev/null
	Math file1=Data/rrArtM190iter20.H exp='file1*file1' | Grey $(gpar5) title='(d)' wantaxis2=1  wantaxis1=0 out=junk4.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=1 yshift=8. > 1.v
	vppen < junk2.v vpstyle=n xshift=6.5 yshift=8. > 2.v
	vppen < junk3.v vpstyle=n xshift=1 yshift=0 > 3.v
	vppen < junk4.v vpstyle=n xshift=6.5 yshift=0 > 4.v
	vppen 1.v 2.v 3.v 4.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v 3.v 4.v junk*.v


Vfig5wgt.v:
	python pycode/pyRemove.py $@ tmp1.H
	< Data/FmodD220.H Grey $(gpar5) title='(a)' wantaxis2=1 out=junk1.v >/dev/null
	< Data/dwfileD220.H Grey $(gpar5) title='(b)' wantaxis1=0 wantaxis2=1 color=j newclip=1 wantscalebar=1 out=junk2.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=0 > 1.v
	vppen < junk2.v vpstyle=n xshift=6. yshift=0 > 2.v
	vppen 1.v 2.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v 3.v 4.v junk*.v



extractfile:
	cp LSM/C/m/mArtCTotaliter2.H Data/.
	cp LSM/C/m/mArtCTotaliter20.H Data/.
	cp LSM/C/m/mArtFTotaliter20.H Data/.
	cp LSM/C/m/mArtMTotaliter20.H Data/.
	cp LSM/F/rr/rrArtF190iter1.H Data/.
	cp LSM/F/rr/rrArtF190iter20.H Data/.
	cp LSM/M/rr/rrArtM190iter1.H Data/.
	cp LSM/M/rr/rrArtM190iter20.H Data/.
	cp Data/F/FmodD220.H Data/.
	cp DWfile/D/dwfileD220.H Data/.

