#! /usr/bin/env python
#from SEP import *
import commands,re,string,sys,os
import datetime
import sys
from array import *
#import Numeric
import subprocess

# This script submit 100 jobs but only 4 jobs is running at a time
# it constantly check rather a there are < 4 jobs, if so it submit more


from pyLoc import *

plet='D'

Nproc=400

maindir = './Data/D'


savDir = "%s"%(maindir)
sbin = "bin"
sepb = "/usr/local/SEP/bin"
nodes = 1   # number of nodes for each job
ppn=16     # number of processor per node
walltime='24:00:00'  # max time to wait for the job to finish
pmem = '2gb'  # max memory to allocate for the job
jobname = 'Fmod%s_'%(plet) # Job name 

parfile = 'Par/synFmod1.par'

os.system("rm -f out1.par; sed '/#/d' %s | sed '/^$/d' | tr '\n' ' ' > out1.par"%(parfile))
f1 = open("out1.par")
param = f1.readline()
f1.close()
print 'param', param

#for i in [10]:	
for i in K[:]:
	a1 = '%s'%(L[i][0])
	Gx = L[i][0]
	Gy = L[i][1]
	Gz = L[i][2]
	submitted = 0
	if (os.path.isdir('%s/pbs'%(savDir)) != 1):
		os.system('mkdir %s/pbs'%(savDir))
	if (os.path.isdir('%s/logfile'%(savDir)) != 1):
		os.system('mkdir %s/logfile'%(savDir))
	cmdfile = "%s/pbs/PBS%s%s.txt"%(savDir,plet,i)
	logfile = "%s/logfile/fm%s.txt"%(savDir,i)
	os.system("rm -f %s %s"%(cmdfile,logfile))
	while (submitted == 0):
		# flag = number of job running
		cmd0="qstat | grep \"mandyman\" | grep \"%s\" -c >& %s/count.txt"%(jobname,savDir)
		os.system(cmd0)
		stg1 = "%s/count.txt"%(savDir)
		f = open(stg1)
		os.system("rm -f %s/count.txt"%(savDir))
		flag = int(f.readline())	
		f.close()
		print 'number of proc found', flag	
		
		if (flag < Nproc):
			print 'Fmod1: submitting shot #', i
			cmd0 ='python pycode/pyRemove.py %s/Fmod%s%s.H %s/tmp%s%s.H %s/souWfld%s.H'%(savDir,plet,i,savDir,plet,i,savDir,i)
			cmd1 = 'bin/Synth_data.x < Input/velZigsmoothv2.H aux=Input/wavelet.H %s xsrc=%s zsrc=%s npad=30 wfldout=0 souwfld="%s/souwfld%s.H" outfile=%s/tmp%s%s.H >& %s'%(param,Gx,Gz,savDir,i,savDir,plet,i,logfile)
			print cmd1
			cmd2 = '< %s/tmp%s%s.H  ${SEPBIN}/Bandpass flo=3. fhi=25. > %s/Fmod%s%s.H'%(savDir,plet,i,savDir,plet,i)
			cmd3 = 'python pycode/pyRemove.py %s/tmp%s%s.H Data/E/DmodE%s.H'%(savDir,plet,i,i)
			# Calculate Dmod			
			cmd4 = "bin/updateAB.x alpha=1 beta=-1 naxis=2 file1=Data/A/FmodA%s.H file2=Data/D/FmodD%s.H outfile=Data/E/DmodE%s.H >/dev/null"%(i,i,i)
			cmd5 = 'echo "o2=%s n3=1 d3=1. o3=0." >> Data/D/FmodD%s.H'%(-1*Gx,i)		
			cmd6 = "${SEPBIN}/Mute < Data/D/FmodD%s.H tmute=1. vmute=1500. > Data/D/FmodDmu%s.H"%(i,i)
			cmd7 = 'echo "o2=0." >> Data/D/FmodD%s.H'%(i)	
			cmd8 = 'echo "o2=0." >> Data/D/FmodDmu%s.H'%(i)
			os.system("echo '%s' >> %s"%(cmd0,cmdfile))
			os.system("echo '%s' >> %s"%(cmd1,cmdfile))
			os.system("echo '%s' >> %s"%(cmd2,cmdfile))
			os.system("echo '%s' >> %s"%(cmd3,cmdfile))
			os.system("echo '%s' >> %s"%(cmd4,cmdfile))
			os.system("echo '%s' >> %s"%(cmd5,cmdfile))
			os.system("echo '%s' >> %s"%(cmd6,cmdfile))
			os.system("echo '%s' >> %s"%(cmd7,cmdfile))
			os.system("echo '%s' >> %s"%(cmd8,cmdfile))
			# generate the pbs scripts 
			cmd1 = "pycode/pyWritePBS.py %s %s %s %s %s%s %s"%(nodes,ppn,walltime,pmem,jobname,i,cmdfile)
			os.system( cmd1)
			submitted = 1
			os.system('sleep 2')
		else:
			print 'Number of proc',flag,'wait 20'
			os.system("sleep 20")

flag=1

while (flag > 0):	
	# flag = number of job running
	os.system("qstat | grep \"mandyman\" | grep \" C \" -v | grep \"%s\" -c >& %s/count.txt"%(jobname,savDir)) 
	f = open("%s/count.txt"%(savDir))
	os.system("rm -f %s/count.txt"%(savDir))
	flag = int(f.readline())	
	f.close()	
	os.system("rm -f %s/count.txt"%(savDir))
	print "Number of proc",flag,",not done yet, sleep 20"
	os.system("sleep 20")


print "Good bye!"


